=== debian/changelog ===
warzone2100 (4.5.5deb-1) unstable; urgency=medium

  * Created a new orig.tar.xz to deal with Lintian error

 -- Russell Coker <russell@coker.com.au>  Tue, 21 Jan 2025 21:23:08 +1100

warzone2100 (4.5.5-1) unstable; urgency=medium

  * New upstream version, bug fixes, in-game options button, amd high quality
    water.
  * Changed wrapper to support pipewire sockets
  * Changed build-depends from pkg-config to pkgconf
  * Change the lintian format for the ftp master scripts

 -- Russell Coker <russell@coker.com.au>  Sun, 19 Jan 2025 16:00:25 +1100

warzone2100 (4.5.3-1) unstable; urgency=medium

  * New upstream version, mostly bug fixes
  * Rename lintian overrides file to try and make it work

 -- Russell Coker <russell@coker.com.au>  Sun, 20 Oct 2024 12:29:42 +1100

warzone2100 (4.5.2-1) unstable; urgency=medium

  * New upstream version, mostly bug fixes

 -- Russell Coker <russell@coker.com.au>  Mon, 26 Aug 2024 22:55:13 +1000

warzone2100 (4.5.1-1) unstable; urgency=medium

  * New upstream version, bug fixes and tweaks.
  * Fixed lintian issues.

 -- Russell Coker <russell@coker.com.au>  Wed, 31 Jul 2024 17:38:47 +1000

warzone2100 (4.5.0-1) unstable; urgency=medium

  * New upstream release that compiles with GCC 14 Closes: #1075631
  * Two new campaigns
  * Trees look nicer!
  * Added lintian override for license-problem-json-evil because we aren't
    building with Discord support and therefore
    3rdparty/discord-rpc/thirdparty/rapidjson/license.txt is not relevant.
    If in future we add Discord support we should Build-Depend on
    rapidjson-dev.
  * Change build-depends from libfreetype6-dev to libfreetype-dev
  * Made override_dh_clean call dh_clean
  * Removed many obsolete entries from debian/copyright

 -- Russell Coker <russell@coker.com.au>  Sun, 07 Jul 2024 16:00:29 +1000
